Package org.apache.wiki.search

# Class DefaultSearchManager.JSONSearch

java.lang.Object
org.apache.wiki.search.DefaultSearchManager.JSONSearch

All Implemented Interfaces:
  `WikiAjaxServlet`

Enclosing class:
  DefaultSearchManager

public class DefaultSearchManager.JSONSearch extends Object implements WikiAjaxServlet
Provides a JSON AJAX API to the JSPWiki Search Engine.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`AJAX_ACTION_PAGES`
`static final String`
`AJAX_ACTION_SUGGESTIONS`
`static final int`
`DEFAULT_MAX_RESULTS`
`int`
`maxResults`

## Constructor Summary

Constructors
Constructor
Description
`JSONSearch()`

## Method Summary

Modifier and Type
Method
Description
`List<Map<String,Object>>`
`findPages(String searchString, int maxLength, Context wikiContext)`
Performs a full search of pages.
`String`
`getServletMapping()`
`List<String>`
`getSuggestions(String wikiName, int maxLength)`
Provides a list of suggestions to use for a page name.
`void`
`service(javax.servlet.http.HttpServletRequest req, javax.servlet.http.HttpServletResponse resp, String actionName, List<String> params)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### AJAX_ACTION_SUGGESTIONS

public static final String AJAX_ACTION_SUGGESTIONS

See Also:
  - Constant Field Values

### AJAX_ACTION_PAGES

public static final String AJAX_ACTION_PAGES

See Also:
  - Constant Field Values

### DEFAULT_MAX_RESULTS

public static final int DEFAULT_MAX_RESULTS

See Also:
  - Constant Field Values

### maxResults

public int maxResults

## Constructor Details

### JSONSearch

public JSONSearch()

## Method Details

### getServletMapping

public String getServletMapping()

Specified by:
  `getServletMapping` in interface `WikiAjaxServlet`

### service

public void service(javax.servlet.http.HttpServletRequest req, javax.servlet.http.HttpServletResponse resp, String actionName, List<String> params) throws IOException

Specified by:
  `service` in interface `WikiAjaxServlet`
Throws:
  `IOException`

### getSuggestions

public List<String> getSuggestions(String wikiName, int maxLength)
Provides a list of suggestions to use for a page name. Currently, the algorithm just looks into the value parameter, and returns all page names from that.

Parameters:
  `wikiName` - the page name
  `maxLength` - maximum number of suggestions
Returns:
  the suggestions

### findPages

public List<Map<String,Object>> findPages(String searchString, int maxLength, Context wikiContext)
Performs a full search of pages.

Parameters:
  `searchString` - The query string
  `maxLength` - How many hits to return
Returns:
  the pages found